diff --git a/tests/optimise-store.sh b/tests/optimise-store.sh
index 6eb54ca50875b344726cf504f2e50a3a2fd19718..ea4478693e7832042b5a4c31ef39016ad18266fe 100644
--- a/tests/optimise-store.sh
+++ b/tests/optimise-store.sh
@@ -18,6 +18,23 @@ if [ "$nlink" != 3 ]; then
     exit 1
 fi
 
+outPath3=$(echo 'with import ./config.nix; mkDerivation { name = "foo3"; builder = builtins.toFile "builder" "mkdir $out; echo hello > $out/foo"; }' | nix-build - --no-out-link)
+
+inode3="$(perl -e "print ((lstat('$outPath3/foo'))[1])")"
+if [ "$inode1" = "$inode3" ]; then
+    echo "inodes match unexpectedly"
+    exit 1
+fi
+
+nix-store --optimise
+
+inode1="$(perl -e "print ((lstat('$outPath1/foo'))[1])")"
+inode3="$(perl -e "print ((lstat('$outPath3/foo'))[1])")"
+if [ "$inode1" != "$inode3" ]; then
+    echo "inodes do not match"
+    exit 1
+fi
+
 nix-store --gc
 
 if [ -n "$(ls $NIX_STORE_DIR/.links)" ]; then